%if 0%{?fedora} < 28
%global with_python2 1
%endif

%if 0%{?fedora} >= 22
%global with_python3 1
%endif

%define author mgaitan
%define unmangled_name waliki
%define unmangled_version 0.8.1

Summary: An extensible wiki app for Django with a Git backend
Name: python-django-%{unmangled_name}
Version: %{unmangled_version}
Release: 5%{?dist}.1
Source0: https://github.com/%{author}/%{unmangled_name}/archive/%{version}/%{unmangled_name}-%{version}.tar.gz
Patch0: python-django-waliki-no-rst2html5.patch
Patch1: python-django-waliki-no-context.patch
Patch2: python-django-waliki-django2.patch
License: BSD
Group: Development/Libraries
Prefix: %{_prefix}
BuildArch: noarch
Vendor: Martín Gaitán <gaitan@gmail.com>
Url: https://github.com/mgaitan/waliki
%if 0%{?with_python2}
BuildRequires: python2-devel
BuildRequires: python-setuptools
BuildRequires: python-django >= 1.5.1
BuildRequires: python-markups
BuildRequires: python-sh
BuildRequires: python-docutils
BuildRequires: python-genshi
BuildRequires: python-pyquery
BuildRequires: python2-django-nose
BuildRequires: python-factory-boy
BuildRequires: python-fake-factory
BuildRequires: python-markdown
BuildRequires: python-django-sendfile
BuildRequires: python-mock
%endif
BuildRequires: hovercraft
%if 0%{?with_python3}
BuildRequires: python3-devel
BuildRequires: python3-setuptools
BuildRequires: python3-django >= 1.5.1
BuildRequires: python3-markups
BuildRequires: python3-sh
BuildRequires: python3-docutils
BuildRequires: python3-genshi
BuildRequires: python3-pyquery
BuildRequires: python3-django-nose
BuildRequires: python3-factory-boy
BuildRequires: python3-fake-factory
BuildRequires: python3-markdown
BuildRequires: python3-django-sendfile
BuildRequires: python3-mock
%endif
BuildRequires: git-core

%description
Waliki is an extensible wiki app for Django with a Git backend.

At a glance, Waliki has these features:

* File based content storage.
* UI based on Bootstrap and CodeMirror
* Version control and concurrent edition for your content using git
* An extensible architecture through plugins
* reStructuredText or Markdown support, configurable per page
  (and it's easy to add extensions)
* A very simple *per slug* ACL system
* A nice attachments manager (that respects the permissions over the page)
* Realtime collaborative edition via togetherJS
* Wiki content embeddable in any django template (as a "dummy CMS")
* Few helpers to migrate content (particularly from MoinMoin, using moin2git)
* It works with Python 2.7, 3.3, 3.4 or PyPy in Django 1.6 or newer

It's easy to create a site powered by Waliki using the preconfigured project
which is the same code that motorize the demo.

Waliki was inspired in Github's wikis, but it tries to be a bit smarter
than many others git backed wiki engines at handling changes:
instead of a hard "newer wins" or "page blocking" approaches,
Waliki uses git's merge facilities on each save.
So, if there was another change during an edition and git can merge them
automatically, it's done and the user is notified.
If the merge fails, the last edition is still saved but the editor is
reloaded asking the user to fix the conflict.

%if 0%{?with_python2}
%package -n python2-django-%{unmangled_name}
Summary: An extensible wiki app for Django with a Git backend
Group: Development/Libraries
Requires: python-django
Requires: python-markups
Requires: python-sh
Requires: python-docutils
Requires: python-genshi
Requires: python-pyquery
Requires: python-micawber >= 0.3.0
Requires: python-markdown
Requires: python-django-sendfile
Requires: rst2pdf
Requires: hovercraft
Requires: git-core
%{?python_provide:%python_provide python2-django-%{unmangled_name}}

%description -n python2-django-%{unmangled_name}
Waliki is an extensible wiki app for Django with a Git backend.

At a glance, Waliki has these features:

* File based content storage.
* UI based on Bootstrap and CodeMirror
* Version control and concurrent edition for your content using git
* An extensible architecture through plugins
* reStructuredText or Markdown support, configurable per page
  (and it's easy to add extensions)
* A very simple *per slug* ACL system
* A nice attachments manager (that respects the permissions over the page)
* Realtime collaborative edition via togetherJS
* Wiki content embeddable in any django template (as a "dummy CMS")
* Few helpers to migrate content (particularly from MoinMoin, using moin2git)
* It works with Python 2.7, 3.3, 3.4 or PyPy in Django 1.6 or newer

It's easy to create a site powered by Waliki using the preconfigured project
which is the same code that motorize the demo.

Waliki was inspired in Github's wikis, but it tries to be a bit smarter
than many others git backed wiki engines at handling changes:
instead of a hard "newer wins" or "page blocking" approaches,
Waliki uses git's merge facilities on each save.
So, if there was another change during an edition and git can merge them
automatically, it's done and the user is notified.
If the merge fails, the last edition is still saved but the editor is
reloaded asking the user to fix the conflict.

This package contains the python2 version of this module.
%endif

%if 0%{?with_python3}
%package -n python3-django-%{unmangled_name}
Summary: An extensible wiki app for Django with a Git backend
Group: Development/Libraries
Requires: python3-django
Requires: python3-markups
Requires: python3-sh
Requires: python3-docutils
Requires: python3-genshi
Requires: python3-pyquery
Requires: python3-micawber >= 0.3.0
Requires: python3-markdown
Requires: python3-django-sendfile
Requires: rst2pdf
Requires: hovercraft
Requires: git-core
%{?python_provide:%python_provide python3-django-%{unmangled_name}}

%description -n python3-django-%{unmangled_name}
Waliki is an extensible wiki app for Django with a Git backend.

At a glance, Waliki has these features:

* File based content storage.
* UI based on Bootstrap and CodeMirror
* Version control and concurrent edition for your content using git
* An extensible architecture through plugins
* reStructuredText or Markdown support, configurable per page
  (and it's easy to add extensions)
* A very simple *per slug* ACL system
* A nice attachments manager (that respects the permissions over the page)
* Realtime collaborative edition via togetherJS
* Wiki content embeddable in any django template (as a "dummy CMS")
* Few helpers to migrate content (particularly from MoinMoin, using moin2git)
* It works with Python 2.7, 3.3, 3.4 or PyPy in Django 1.6 or newer

It's easy to create a site powered by Waliki using the preconfigured project
which is the same code that motorize the demo.

Waliki was inspired in Github's wikis, but it tries to be a bit smarter
than many others git backed wiki engines at handling changes:
instead of a hard "newer wins" or "page blocking" approaches,
Waliki uses git's merge facilities on each save.
So, if there was another change during an edition and git can merge them
automatically, it's done and the user is notified.
If the merge fails, the last edition is still saved but the editor is
reloaded asking the user to fix the conflict.

This package contains the python3 version of this module.
%endif

%prep
%setup -n %{unmangled_name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
export LANG=C.UTF-8
%if 0%{?with_python2}
%py2_build
%endif
%if 0%{?with_python3}
%py3_build
%endif

%install
export LANG=C.UTF-8
%if 0%{?with_python3}
%py3_install
%endif
%if 0%{?with_python2}
%py2_install
%endif

%check
%if 0%{?with_python2}
LANG=C.UTF-8 %{__python2} runtests.py
%endif

%if 0%{?with_python3}
LANG=C.UTF-8 %{__python3} runtests.py
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if 0%{?with_python2}
%files -n python2-django-%{unmangled_name}
%defattr(-,root,root)
%license LICENSE
%doc *.rst
%{python2_sitelib}/%{unmangled_name}
%{python2_sitelib}/%{unmangled_name}-%{version}-py?.?.egg-info
%endif

%if 0%{?with_python3}
%files -n python3-django-%{unmangled_name}
%defattr(-,root,root)
%license LICENSE
%doc *.rst
%{python3_sitelib}/%{unmangled_name}
%{python3_sitelib}/%{unmangled_name}-%{version}-py?.?.egg-info
%endif
%changelog
* Tue May  1 2018 Oleg Girko <ol@infoserver.lv> 0.8.1-5
- Enable build without Python 2 (new Django supports Python 3 only)
- Add patch to support Django 2.0
* Mon Nov 27 2017 Oleg Girko <ol@infoserver.lv> 0.8.1-4
- Add backported patch for compatibility with Django 1.11
* Tue Oct 10 2017 Oleg Girko <ol@infoserver.lv> 0.8.1-3
- Require git-core
* Mon Mar 27 2017 Oleg Girko <ol@infoserver.lv> 0.8.1-2
- Don't require rst2html5 module
* Sun Mar 26 2017 Oleg Girko <ol@infoserver.lv> 0.8.1-1
- Update to version 0.8.1
* Tue Dec 20 2016 Oleg Girko <ol@infoserver.lv> 0.7-1
- Update to version 0.7
- Remove all patches, they are all upstreamed to version 0.7
* Fri Dec 16 2016 Oleg Girko <ol@infoserver.lv> 0.6-3
- Slightly improve one patch fixing problems with markups 2.0
* Tue Dec 13 2016 Oleg Girko <ol@infoserver.lv> 0.6-3
- Add patches for compatibility with Django 1.9
- Add patches to fix problems with markups 2.0
- Simplify spec file and make it more modern
- Build python2-django-waliki package instead of python-django-waliki
* Sat Nov 14 2015 Oleg Girko <ol@infoserver.lv> 0.6-2
- Enable build with Python 3
- Improve patch to run commands with output to pipe with some missed cases
* Fri Nov 13 2015 Oleg Girko <ol@infoserver.lv> 0.6-1
- Update to version 0.6
* Fri Sep 11 2015 Oleg Girko <ol@infoserver.lv> 0.6~0.1.20150608.git165d86-2
- Run proper tests
* Thu Sep 10 2015 Oleg Girko <ol@infoserver.lv> 0.6~0.1.20150608.git165d86-1
- Initial package
